/*******************************************************************************
 * FoxProjectile_StickyGrenadeBase generated by Eliot.UELib using UE Explorer.
 * Eliot.UELib ? 2009-2015 Eliot van Uytfanghe. All rights reserved.
 * http://eliotvu.com
 *
 * All rights belong to their respective owners.
 *******************************************************************************/
class FoxProjectile_StickyGrenadeBase extends FoxProjectile_ThrownBase
    abstract
    native(Weapon)
    config(Projectile)
    hidecategories(Navigation);

var const float StickExplosionTime;
var const AkEvent PlayLoopingAudio;
var const AkEvent StopLoopingAudio;
var const ParticleSystem TomahawkFlare;
var bool bMiniGameIsOpen;
var bool bWantsToExplode;
var Vector SensorLocation;

simulated function HandleStickTo(StickToDetails NewStickToInfo)
{
    // End:0x27
    if(PlayLoopingAudio != none)
    {
        PlayAkEvent(PlayLoopingAudio, true);
    }
    SensorLocation = Location;
    super.HandleStickTo(NewStickToInfo);
    // End:0x16C
    if((WorldInfo.NetMode != NM_DedicatedServer) && (FoxPawn(NewStickToInfo.StickToActor) == none) || !FoxPawn(NewStickToInfo.StickToActor).IsLocallyControlled())
    {
        TrailEmitterComponent.DeactivateSystem();
        TrailEmitterComponent.SetTemplate(TomahawkFlare);
        TrailEmitterComponent.SetHidden(false);
        TrailEmitterComponent.ActivateSystem();
    }
    // End:0x199
    if((Role == ROLE_Authority) && bWantsToExplode)
    {
        DoExplosion();
    }
    //return;    
}

simulated function DoExplosion()
{
    // End:0x38
    if((Role == ROLE_Authority) && Physics != 0)
    {
        bWantsToExplode = true;
        return;
    }
    // End:0x5F
    if(StopLoopingAudio != none)
    {
        PlayAkEvent(StopLoopingAudio, true);
    }
    Explode(((StickToInfo.bStickToPawn) ? Location : SensorLocation - vect(0.0, 0.0, 16.0)), vect(0.0, 0.0, 1.0));
    //return;    
}

simulated function Destroyed()
{
    // End:0x27
    if(StopLoopingAudio != none)
    {
        PlayAkEvent(StopLoopingAudio, true);
    }
    super.Destroyed();
    //return;    
}

defaultproperties
{
    StickExplosionTime=1.50
    bTurnOffCollision=false
    begin object name=StaticMeshComponent0 class=StaticMeshComponent
        ReplacementPrimitive=none
    object end
    // Reference: StaticMeshComponent'Default__FoxProjectile_StickyGrenadeBase.StaticMeshComponent0'
    Mesh=StaticMeshComponent0
    IndirectTimerLength=7.0
    ProjLightEnvironment=DynamicLightEnvironmentComponent'Default__FoxProjectile_StickyGrenadeBase.MyLightEnvironment'
    begin object name=CollisionCylinder class=CylinderComponent
        ReplacementPrimitive=none
    object end
    // Reference: CylinderComponent'Default__FoxProjectile_StickyGrenadeBase.CollisionCylinder'
    CylinderComponent=CollisionCylinder
    begin object name=CollisionCylinder class=CylinderComponent
        ReplacementPrimitive=none
    object end
    // Reference: CylinderComponent'Default__FoxProjectile_StickyGrenadeBase.CollisionCylinder'
    Components(0)=CollisionCylinder
    Components(1)=DynamicLightEnvironmentComponent'Default__FoxProjectile_StickyGrenadeBase.MyLightEnvironment'
    begin object name=StaticMeshComponent0 class=StaticMeshComponent
        ReplacementPrimitive=none
    object end
    // Reference: StaticMeshComponent'Default__FoxProjectile_StickyGrenadeBase.StaticMeshComponent0'
    Components(2)=StaticMeshComponent0
    bProjTarget=true
    LifeSpan=60.0
    begin object name=CollisionCylinder class=CylinderComponent
        ReplacementPrimitive=none
    object end
    // Reference: CylinderComponent'Default__FoxProjectile_StickyGrenadeBase.CollisionCylinder'
    CollisionComponent=CollisionCylinder
}